; VP 14.03.2017
; der orig. EPROM (rechts) hat offentsichtlich ein paar Bitfehler:
;000220: 78 03 38 DE ED 5B*EB 13 | 78 03 38 DE ED 5B*6B 13
;000288: C8 23*77 2B C9 3E 01 06 | C8 23*57 2B C9 3E 01 06
;000308: 3A 04 10 FB 0D 20*E7 0E | 3A 04 10 FB 0D 20*67 0E
;000328: DD 2B 0D 20*E8*E1 C9 D9 | DD 2B 0D 20*68*41 C9 D9
;0003A0: 11 38 06 2D 2D*CB C4 18 | 11 38 06 2D 2D*4B C4 18
;0003A8: F1 2C*CB 44*28*EC CB 15 | F1 2C*4B 44*08*CC CB 15
;auerdem scheint es eine Arbeitsversion zu sein:
;RST/NMI-UP wird nicht verwendet; das UP wird auf 1270 eingetragen, aber
;nicht genutzt.  
;der neue RST7 endet mitten im Code.

	CPU	z80

;        PIO-PORTS:

SEGMENT  EQU 074H ;AUSGABE-PORT SEGMENTANSTEUERUNG
PIO1AC   EQU 076H

DIGITAP  EQU 075H ;B2...B7=DIGITANST. UND TASTENMATRIX
                  ;B0=TAPE-IN, B1=TAPE-OUT
PIO1BC   EQU 077H

USERPORT EQU 078H ;U8ER-PORT, FREI VERFUEGBAR
PI02AC   EQU 07AH

KEYIN    EQU 079H ;B4...B7=EINGAENGE TASTEN-ABFRAGE
                  ;B0...B3 FUER USER NUTZBAR
PIO2BC   EQU 07BH

;VEREINBARUNGEN BEI ERWEITERUNGEN
INTVEK   EQU 00H       ;INT-VECT. FUER CTC
HIINT    EQU 23H       ;CPU-I-REG


;*****************************************************
;
         ORG 0000H
START:
   LD B,00H        ;EIN8CHALTVERZOEGERUNG
   DJNZ $
   ld	a, 17h
   JR loc_B

         ORG 08H
RST1:
   JP 1210H

loc_B:		
	out	 (USERPORT), a
	jr	 loc_13

         ORG 10H
RST2:
   JP 1220H

loc_13:
	out	(KEYIN), a
	jr	loc_1B

         ORG 18H
RST3:
   JP 1230H

loc_1B:
	ld	a, 0FFh
	jr	loc_23

         ORG 20H
RST4:
   JP 1240H

loc_23:
	out	(USERPORT), a
	jr	loc_2B

         ORG 28H
RST5:
   JP 1250H

loc_2B:
	out	(KEYIN), a
	jr	NOFF

         ORG 30H
RST6:
   JP 1260H

         ORG 38H
RST7:
	push	af
	push	bc
	ld	a, 0Fh
	ld	b, 0
loc_3E:
	djnz	loc_3E
	dec	a
	jr	nz, loc_3E
	pop	bc
	pop	af
	;???
	ld	b, e
	ld	(hl), b
	ld	(de), a
	;??? nicht ganz sinnvoll, hier aufzuhoeren
	;vermutlich in Entwicklung
	;Adr 1270h wird auch nicht weiter benutzt...

NOFF:
   LD SP,SPINI    ;SP AUF ANFANGSWERT
	ld	bc, RSTLGT
	ld	de, 1270h
	ld	hl, RSTUP
	ldir
	ei
   CALL IOINIT
;--------------------- TEST, OB ERSTEINSCHALTUNG ----
   LD A,(INIFLAG)
   CP 80H
   CALL NZ,INI    ;MUSIK U. GRAPHIK, WENN ERSTEINSCH.
	jr	loc_69

;-------------------- NMI-FKT. ANSPRINGEN ----------
         ORG 0066H
NMI:
   JP 1280H

;--------------------- RESETZUSTAND HERSTELLEN ------
loc_69:
   LD HL,1000H
   LD (USERPC),HL ;USER-PC AUF ANFANGSWERT
   XOR A
   LD (FUFEFLAG),A;FUNKTIONS- UND FEHLERFLAG LOESCHEN
   LD IX,DISP1    ; "LC80"-TEXT
;--------------------- TEXT, ADR.- U. TAPE-CODE LOE.
SETSTO:
   XOR A
   LD (ATCODE),A

;--------------------- HAUPTPROGRAMM ----------------
MAIN:
   LD SP,SPINI    ;USER-PC AUF ANFANGSWERT
   CALL DAK1      ;ANZEIGE UND TASTATURABFRAGE
   CALL KEYEXC    ;TASTENBEHANDLUNG
   JR MAIN

;---------------------- IO-INITIALISIERUNG -----------
IOINIT:           ;PIO-INITIALISIERUNG
   LD A,0CFH      ;MODE 3
   OUT (PIO1AC),A ;SEGMENT-PORT
   LD A,0FFH
   OUT (SEGMENT),A;ALLE SEGMENTE AUSSCHALTEN
   LD A,0         ;E-A-DEFINITION
   OUT (PIO1AC),A

   LD A,0CFH
   OUT (PIO1BC),A ;DIGIT-AUSG.
                  ;B2...B7 = D-LSD,D-MSD,A-LSD...A-MSD
   LD A,0FFH      ;ALLE TREIBER SPERREN
   OUT (DIGITAP),A
   LD A,1          ;B0-EINGANG, B1...B7-AUSGAENGE
   OUT (PIO1BC),A

   LD A,0CFH
   OUT (PIO2BC),A ;TASTEN-EINGAENGE B4...B7
   LD A,0FFH
   OUT (PIO2BC),A
   RET

;-----------------------------------------------------
RSTUP:
   JP RSTUP1
RSTLGT EQU $-RSTUP

RSTUP1:
		push	af
		ld	a, i
		jp	po, INTUP
		pop	af
   LD IX,DISP6
   JP SETSTO

;-----------------------------------------------------
INTUP:
		push	bc
		ex	af, af'
		push	af
		exx
		push	bc
		push	de
		push	hl
		exx
		push	ix
		ld	b, 10h		;ANZEIGEZEIT "INT"
		ld	ix, DISP5
INTUP1:
		call	DAK2
		djnz	INTUP1
		ld	a, (INIFLAG)
		cp	80h 
		jp	z, INTUP2
		ld	a, 80h
		ld	(INIFLAG), a
		ei
		jp	NOFF
;-----------------------------------------------------

INTUP2:
		pop	ix
		exx
		pop	hl
		pop	de
		pop	bc
		exx
		pop	af
		ex	af, af'
		pop	bc
		pop	af
		ei
		reti


;--------------------- TASTENBEHANDLUNGSPROGRAMM ----
;                 EINTRITT: INTERNER TASTENCODE IN A
KEYEXC:
   CP 10H         ;TEST, OB FUNKTIONSTASTE
   JR  C,KHEX     ;SPR., WENN ZIFFERNTASTE
   LD HL,FUFEFLAG ;FLAG "FUNKTIONSTASTE" SETZEN
   SET 0,(HL)
   SUB 10H        ;OBERE ZIFFER DES CODES LOESCHEN
   CP 08H         ;TEST DER FUNKTIONSGRUPPE
   LD HL,KSUFUN
   JP  C,BRANCH   ; WENN "+","-","EXEC" O. "DATA"-TASTE

                  ;ADR- ODER TAPE-TASTEN
   LD IX,DATLED   ;ADR. FUER DATEN- U. ADR.-ANZEIGE
   SUB 08H
   LD HL,ATCODE
   LD (HL),A      ;UMGERECHN. CODE HINTERLEGEN
   LD HL,ATFLAG
   LD (HL),0      ;FLAG LOESCHEN
   LD HL,KFUN
   JP BRANCH

;----------------- AUSWERTUNG ZIFFERNTASTEN ---------
KHEX:
   LD C,A         ;TASTATURCODE UMSPEICHERN
   LD HL,HTAB
BR1:
   LD A,(ATCODE)  ;WERT FUER AUSZUF. FUNKTION
   JP BRANCH

;--------------------- EINTR.PKTE FUER +,-,EXEC,DATA -
;                           (UEBER KSUFUN-TABELLE)
KINC:             ; "+"-TASTE
   LD HL,ITAB
   JR BR1

KDEC:             ; "-"-TASTE
   LD HL,DTAB
   JR BR1

KEXEC:            ; "EXEC"-TASTE
   LD HL, ETAB
   JR BR1

KDATA:            ; "DATA"-TASTE
   CALL TESTM     ;TEST. OB ADR OD. DAT IN ATCODE
   CALL MEMDP2    ;ADR U. DAT. ANZ., DAT. GEPUNKTET
   RET

;--------------------- EINTR.PKTE FUER ADRS U. TAPE -
;                           (UEBER KFUN-TABELLE)
KADRS:            ; "ADRS"-TASTE
   CALL MEMDP1    ;ADR. U. DAT. ANZ., ADR. GEPUNKTET
   RET

KTAPWR:           ; "TO TAPE"- ODER "FROM TAPE"-TASTE
   CALL STEPDP    ;PARAMETER ANZEIGEN
   RET

;--------------------- EINTR.PKTE FUER ZIFFERNEINGABEN
;                           (UEBER HTAB-TABELLE)
HFIX:             ; BEDIENUNGSFEHLER
   JP ERRDIS

HDA:              ;ZIFFER ALS DATUM
   LD HL,(USERPC)
   CALL RAMCHK    ;TEST, OB USER-PC IM RAM-BEREICH
   JP NZ,ERRDIS   ;SPR., WENN KEIN RAM
   CALL PRECL1    ;1 BYTE LOE., WENN FUFEFLAG NICHT 0
   LD A,C         ;EINGEG. ZIFFER
   RLD            ;TETRADE IN RAM SCHIEBEN
   CALL MEMDP2    ;ANZEIGEN
   RET

HAD:              ;ZIFFER ALS ADRESSE
   LD HL,USERPC
   CALL PRECL2    ;2 BYTE LOE., WENN FUFEFLAG NICHT 0
   LD A,C         ;EINGEG. ZIFFER
   RLD            ;TETRADEN IN BEIDEN BYTE VERSCHIEBEN
   INC HL
   RLD
   CALL MEMDP1    ;ANZEIGEN
   RET

HTAPWR:           ;ZIFFER ALS PARAMETER FUER BAND
   CALL LOCTBF    ;ADR FUER PARAMETER BERECHNEN
   CALL PRECL2    ;2 BYTE LOE., WENN FUFEFLAG NICHT 0
   LD A,C         ;EINGEG. ZIFFER
   RLD            ;TETRADE IN BEIDEN BYTE VERSCHIEBEN
   INC HL
   RLD
   CALL STEPDP    ;PARAMETER ANZEIGEN
   RET

;---------------------- UNTEREINTRITT "+"-TASTE ----
;                            (UEBER ITAB)
IFIX:             ;BEDIENUNGSFEHLER
   JP ERRDIS

ADRADD:           ;ANWENDER-PC ERHOEHEN
   LD HL,(USERPC)
   INC HL
   LD (USERPC),HL
   CALL MEMDP2    ;ANZEIGEN
   RET

TPFUN1:           ;BEI "TO TAPE" NAECHSTER PARAMETER
   LD HL,ATFLAG
   INC (HL)       ;FLAS AUF NEUEN PARAMETER
   CALL LOCTNA    ;PARMETER 'F','S' ODER 'E'
   JR NZ,ISTEP    ;SPRUNG, WENN RICHTIG
   DEC (HL)       ;FLAG AUF ALTEN WERT
   JP ERRDIS      ;FEHLERANZEIGE
ISTEP:
   CALL STEPDP    ;PARAMETER ANZEIGEN
   RET

;--------------------- UNTEREINTRITT "-"-TASTE -----
;                           (UEBER DTAB)
DFIX:             ;BEDIENUNGSFEHLER
   JP ERRDIS

ADRDEC:           ;ANWENDER-PC ERNIDRIGEN
   LD HL,(USERPC)
   DEC HL
   LD (USERPC),HL
   CALL MEMDP2    ;ANZEIGEN
   RET

TPTUN2:           ;BEI "TO TAPE" VORHERIGER PARAMETER
   LD HL,ATFLAG
   DEC (HL)       ;FLAG AUF VORHER. PARAMETER
   CALL LOCTNA    ;PARAMETER 'F', 'S' ODER 'E'
   JR NZ,DSTEP    ;SPR., WENN RICHTIG
   INC (HL)       ;ALTER FLAGWERT
   JP ERRDIS      ;FEHLERANZEIGE
DSTEP:
   CALL STEPDP    ;PARAMETER ANZEIGEN
   RET

;--------------------- UNTEREINTRITT "EXEC"-TASTE ---
;                           (UEBER ETAB)
EFIX:             ;BEDIENUNGSFEHLER
   JP ERRDIS

ADREXC:           ;PROGRAMAUSFUEHRUNG AB USER-PC
   PUSH HL
   LD HL,(USERPC)
   EX (SP),HL
   RET

ENDFUN:           ; DE IN USER-PC ABSP. UND ANZEIGEN
   LD (USERPC),DE
   CALL MEMDP2
   RET

EWT:              ;UEBERSPIELEN AUF BAND
   CALL SUM       ;PRUEFSUMME BERECHNEN
   JR  C,EFIX     ;WENN ENDADR<ANF.ADR
   LD (CHKSUMH),A ;ABSPEICHERN
   LD HL,0FA0H    ;AUSGABE 4000 x 1KHZ-TAKTE
                  ;ALS START-SYNC SIGNAL
   CALL SOUN1K
   LD HL,FILNAME  ;DESCRIPTOR UEBERTRAGEN
   LD BC,0007H    ;7 BYTE
   CALL TAPOUT
   LD HL,0FA0H    ;AUSGABE 4000 x 2KHZ-TAKTE
                  ;ALS MITTEL-SYNC SIGNAL
   CALL SOUN2K
   CALL GETPTR    ;LAENGE DES BLOCKES BER.
   CALL TAPOUT    ;DATE UEBERTRAGEN
   LD HL,0FA0H    ;AUSGABE 4000 x 2KHZ-TAKTE
                  ;ALS END SYNC. SIGNAL
   CALL SOUN2K
ENDTAP:
   LD DE,(ENDADRH);STARTADR
   JR ENDFUN      ;ABSP. UND ANZEIGEN

;----------------- FEHLERTEXT LADEN, SPR. Z. ANZEIGE -
ERROR:
   LD  IX,ERR     ;ADR FEHLERTEXT
   JP SETSTO      ;SPR. ZUR ANZEIGE

;----------------- DATEN VOM BAND LESEN --------
LOAD:
   LD HL,(FILNAME)
   LD  (FILE2),HL
   LD A,0EFH      ;DEZIMALPUNKTE EIN
   LD  (TAPDIS),A
LEAD:
   LD A,(TAPDIS)
   OUT  (SEGMENT),A
   LD HL,1000
LEAD1:
   CALL PERIOD    ;EMPANGSFREQUENZ FESTSTELLEN
   JR  C,LEAD     ;WDHLG., SOLANGE NICHT 1 KHZ
   DEC HL         ;TEST, OB 1000 MAL 1 KHZ
   LD A,H
   OR L
   JR NZ,LEAD1    ;WDHLG., BIS 1000 x 1 KHZ
LEAD2:
   CALL PERIOD
   JR NC,LEAD2    ;WDHLG., SOLANGE NOCH 1 KHZ
   LD HL,FILNAME  ;ADR FUER HINTERLEGUNG DESCRIPTOR
   LD BC,0007H
   CALL TAPEIN    ;7 BYTE LESEN
   JR  C,LEAD     ;SPR., WENN UEBERTRAGUNGSFEHLER
   LD DE,(FILNAME)
   CALL ADRSDP    ;EMPFANGENEN FILENAMEN DARSTELLEN
   LD B,75
FILEDP:
   CALL DAK2      ;ANZEIGEN
   DJNZ FILEDP
   LD HL,(FILE2)  ;SOLL-NAMEN LESEN
   OR A
   SBC HL,DE
   LD A,0F7H      ;"-"-ZEICHEN
   LD (TAPDIS),A
   JR NZ,LEAD     ;SPR., WENN FALSCHER FILENAME
   LD A,0FEH      ; "'"-ZEICHEN EIN
   OUT (SEGMENT),A
   CALL GETPTR    ;LAENGE DES BLOCKES BER.
   JR  C,ERROR    ;WENN ENDADR<ANF.ADR
   CALL TAPEIN    ;DATENSATZ EINLESEN
   JR  C,ERROR    ;SPR., WENN UEBERTR.FEHLER
   CALL SUM       ;PRUEFSUMME BER.
   LD HL,CHKSUMH
   CP (HL)        ;VERGLEICH MIT UEBERTR. PRUEFS.
   JR NZ,ERROR    ;SPR., WENN FEHLER
   JR ENDTAP

;----------------- FUNKTIONSTASTEN AUSWERTEN -------
BRANCH:
   LD E,(HL)      ;ADR DES FUNKTIONSPROGRAMMTEILS
   INC HL
   LD D,(HL)
   INC HL
   PUSH DE
   LD E,A
   LD D,0
   ADD HL,DE
   POP DE
   LD L,(HL)
   LD H,0
   ADD HL,DE      ;ADR DES GEW. PROG. TEILS
   JP (HL)

;----------------- -
ERRDIS:
   LD HL,FUFEFLAG
   SET 7,(HL)
   RET

;----------------- MUSIK UND GRAPHIK BEI ERSTEINSCH. -
INI:
   CALL MONMUS    ; MUSIKPROGRAMM
   CALL INIDIP    ; ANFANGSGRAPHIK
   LD A,80H
   LD (INIFLAG),A ;FLAG AUF INITIALISIERT SETZEN
   RET

;-----------------------------------------------------
PRECL1:
   LD A,(FUFEFLAG)
   OR A
   RET Z          ;RET., WENN KEIN FLAG
   LD A,0
   LD (HL),A      ;ZELLE LOESCHEN
   LD (FUFEFLAG),A;FLAG LOESCHEN
   RET

;---------------------- 2 BYTE IM RAM LOESCHEN ------
PRECL2:
   CALL PRECL1    ;1 BYTE LOE., WENN FUFEFLAG NICHT 0
   RET  Z         ;RET., WENN KEIN FLAG
   INC HL
   LD (HL),A      ;NAECHSTE ZELLE LOESCHEN
   DEC HL
   RET

;--------------------- ADR U. DAT ANZ., ADR GEPUNKTET-
MEMDP1:
   LD A,01H       ;CODE "ADRESSE"
   LD B,04H       ;ANZ. ADRESSSTELLEN
   LD HL,ADRLED
   JR SAV12

;--------------------- ADR U. DAT ANZ.,ADR GEPUNKTET -
MEMDP2:
   LD A,02H       ;CODE "DATEN"
   LD B,02H       ;ANZAHL DATENSTELLEN
   LD HL,DATLED
SAV12:
   LD (ATCODE),A  ;CODE ABSPEICHERN
   EXX
   LD DE,(USERPC) ;ANWENDERADR ANZEIGEN
   CALL ADRSDP
   LD A,(DE)      ;INHALT DER ADRESS. RAM-ZELLE
   CALL DADP      ;DATUM ANZEIGEN
   EXX
SETPT:
   SET 4,(HL)     ; DEZIMALPUNKTE SETZEN
   INC HL
   DJNZ SETPT     ;WDHLG., BIS ALLE DEZIMALPUNKTEPT
   RET

;--------------------- PARAMETER ANZEIGEN ----------
STEPDP:
   CALL LOCTBF    ;PARAMETERADR. BERECHNEN
   LD E,(HL)      ;INHALT DER ADRES. ZELLE NACH DE
   INC HL
   LD D,(HL)
   CALL ADRSDP    ;DARSTELLEN
   LD HL,ADRLED   ;ADR PUNKTIEREN
   LD B,04H
   CALL SETPT
   CALL LOCTNA    ;ZEICHEN FUER PARAMETERANZ. NACH A
   LD L,A
   LD H,08H       ;"-"-ZEICHEN
   LD (DATLED),HL ;IN DATENANZ. DARSTELLEN
   RET

;--------------------- PARAMETERADR. BERECHNEN ----
                  ;EINTTRIT: ----
                  ;AUSTRITT: ADR IN HL
                  ;ZERSTOERT: A
LOCTBF:
   LD A, (ATFLAG) ;PARAMETERCODE
   ADD A,A        ; x 2
   LD HL,FILNAME
   ADD A,L        ; + DESCRIPTOR-AREA
   LD L,A
   RET

;--------------------- ZEICHEN FUER PARAMETERANZEIGE --
                  ;EINTRITT:
                  ;AUSTRITT: ZEICHEN IN A
                  ;ZERSTOERT: DE
LOCTNA:
   LD A,(ATCODE)  ; CODE "FROM TAPE" ODER "TO TAPE"
   SUB 04H        ; - 4
   ADD A,A
   ADD A,A        ; x 4
   LD DE,DISP4    ; ANZEIGETEXT
   ADD A,E
   LD E,A         ;NEUE ADR NACH DE (FROM ODER TO)
   LD A,(ATFLAG)  ;CODE FUER PARAMETER
   ADD A,E
   LD E,A         ;ADRESSE ZEICHEN
   LD A,(DE)
   OR A
   RET

;--------------------- GRAPHIK FUER ANFANGS-ANZEIGE --
INIDIP:
   LD C,05H       ;ANZAHL DER WDHLG.
   LD HL,DISP3    ;TEXT "HALLO "
   PUSH HL
   LD IX,DISP2    ;TEXT " USER "
A1:
   CALL SOU1K
   EX (SP),IX     ;ADRESS-AUSTAUSCH
   LD B,20
A2:
   CALL DAK2
   DJNZ A2
   CALL SOU2K
   LD B,20
A3:
   CALL DAK2
   DJNZ A3
   DEC C
   JR NZ,A1

   LD C,21
   LD IX,DISP4
BLOOP:
   LD B,11
B1:
   CALL DAK2
   DJNZ B1
   BIT 0,C
   JR NZ,B2
   CALL SOU2K
   JR B3
B2:
   CALL SOU1K
B3:
   DEC IX
   DEC C
   JR NZ,BLOOP

   POP HL         ;STACK-KOR.
   RET

;---------------------- 1KHZ  80ms ----------------
SOU1K:
   EXX
   LD HL,80
   CALL SOUN1K
   EXX
   RET

;--------------------- 2KHZ  80ms -----------------
SOU2K:
   EXX
   LD HL,160
   CALL SOUN2K
   EXX
   RET

;--------------------- TONSIGNAL 1KHZ --------------
SOUN1K:
   LD C,32
   JR SOUND

;--------------------- TONSIGNAL 2KHZ --------------
SOUN2K:
   LD C,15

SOUND:
   ADD HL,HL      ; x 2 WEGEN H- UND L-TEIL DES TAKTES
   LD DE,0001H    ;FUER ZAEHLUNG
   LD A,0FFH      ;TAPE.OUT=H, ANZEIGE AUS
SQWAVE:
   OUT (DIGITAP),A
   LD B,C
   DJNZ $         ;ZEITVERZ.
   XOR 2          ;TAPE.OUT=L
   SBC HL,DE
   JR NZ,SQWAVE   ;WDHLG., BIS ALLE TAKTE
   RET

;--------------------- PRUEFSUMME ----------------
                  ;EINTRITT: -
                  ;AUSTRITT: SUMME IN A
SUM:
   CALL GETPTR
   RET C          ;RET., WENN FEHLER
   XOR A
SUMCAL:
   ADD A,(HL)     ;AUFSUMMIEREN
   CPI            ;NAECHSTE ADR
   JP PE,SUMCAL   ;WDHLG., BIS ALLE BYTES
   OR A
   RET

;--------------------- SPEICHERLAENGE BER. ---------
                  ;EINTRITT:
                  ;AUSTRITT: LAENGE IN BC
                  ;          BEI FEHLER CY=1
GETPTR:
   LD HL,STARTADR ;DESCRIPTORAREA
   LD E,(HL)      ;STARTADR
   INC HL
   LD D,(HL)
   INC HL
   LD C,(HL)      ;ENDADR (C ZWI.SP. WEG. ADR IN HL)
   INC HL
   LD H,(HL)
   LD L,C
   OR A           ;CY LOESCHEN
   SBC HL, DE     ;ABSTAND
   LD C,L         ;NACH BC LADEN
   LD B,H
   EX DE,HL
   RET

 ;---------------------- LESEN VOM BAND -------------
                  ;EINTRITT: ZIELANFANGSADR IN HL
                  ;          LAENGE IN BC
                  ;AUSTRITT:
 TAPEIN:
   XOR A
   EX AF,AF'
 TLOOP:
   CALL GTBYTE    ;1 BYTE LESEN
   LD  (HL),E     ;ABSPEICHERN
   CPI            ;NAECHSTE ADR
   JP PE,TLOOP    ;WDHLG., BIS ALLE BYTE
   EX AF,AF'
   RET

 ;-------------------- 1 BYTE VOM BAND LESEN ----
                  ;EINTRITT:
                  ;AUSTRITT: DATENBYTE IN E
 GTBYTE:
   CALL GETBIT    ;STARTBIT
   LD D,08H       ;8 BIT
 GLOOP:
   CALL GETBIT    ;DATENBIT LESEN
   RR E           ;IN E SCHIEBEN
   DEC D
   JR NZ,GLOOP    ;WDHLG., BIS 8 BIT
   CALL GETBIT    ;STOPBIT
   RET

 ;-------------------- 1 BIT VOM BAND LESEN ---------
                  ;EINTRITT:
                  ;AUSTRITT: BIT IN CY
 GETBIT:
   EXX
   LD HL,0000
 COUNT:
   CALL PERIOD    ;TAKTLAENGE
   INC D
   DEC D          ;Z-FLAG SETZEN/RUECKSETZEN
   JR NZ,TERR     ;SPR., WENN ZU GROSS (FEHLER)
   JR  C,SHORTP   ;SPR., WENN 1 KHZ
                  ;FREQU. IST 2 KHZ
   DEC L          ;L=L-2
   DEC L
   SET 0,H        ;H=1
   JR COUNT       ;WDHLG.
SHORTP:
                  ;FREQU. IST 1 KHZ
   INC L          ;L=L+1
   BIT 0,H
   JR  Z,COUNT    ;SPR., WENN NOCH NICHT 2 KHZ EMPFANGEN
   RL L           ;BIT IN CY
   EXX
   RET
TERR:
                  ;FREQUENZ AUSSER ERLAUBTEM BEREICH
   EX AF,AF'
   SCF
   EX AF,AF'
   EXX
   RET

;--------------------- TAKTLAENGE VOM BAND-SIGNAL ----
                  ;EINTRITT: ----
                  ;AUSTRITT: CY=O --> 1 KHZ
                  ;          CY=1 --> 2 KHZ
PERIOD:
   LD DE,0000     ;ZAEHLER = 0
CHK0:
   IN A,(DIGITAP) ;EINLESEN
   INC DE         ;ZAEHLER ERHOEHEN
  RRA
   JR  C,CHK0     ;WDHLG., WENN EINGANG H
   LD A,0         ;AZEIGE FREI, TAPE.OUT = L
   OUT (DIGITAP),A
CHK1:
   IN A,(DIGITAP) ;EINLESEN
   INC DE         ;ZAEHLER ERHOEHEN
  RRA
   JR NC,CHK1     ;WDHLG., WENN EINGANG L
   LD A,2         ; ANZEIGE FREI, TAPE.OUT = H
   OUT (DIGITAP),A
   LD A,E
   CP 22          ;TEST   <> 1,5 KHZ
   RET

;--------------------- DATEN AUF BAND AUSGEBEN ------
                  ;EINTRITT: ANFANGSADR. IN HL
                  ;          ANZAHL IN BC
                  ;AUSTRITT:
TAPOUT:
   LD E,(HL)      ;BYTE NACH E
   CALL OUTBYTE
   CPI            ;NAECHSTES BYTE
   JP PE,TAPOUT   ;WDHLG., WENN NOCH BYTES ZU SENDEN
   RET

;--------------------- EIN BYTE AUSGEBEN ----------
                  ;EINTRITT: BYTE IN E
                  ;AUSTRITT:
OUTBYTE:
   LD D,08H       ;8 BIT
   OR A
   CALL OUTBIT    ;STARTBIT
OLOOP:
   RR E           ;BIT IN CY
   CALL OUTBIT    ;DATENBIT AUSGEBEN
   DEC D
   JR NZ,OLOOP    ;WDHLG., BIS 8 BIT
   SCF
   CALL OUTBIT    ;STOPBIT
   RET

;----------------- -
OUTBIT:
   EXX            ;OUTPUT 1 BIT DATA
   LD H,0
   JR  C,OUT1
OUT0:
   LD L,0CH
   CALL SOUN2K
   LD L,03H
   JR BITEND
OUT1:
   LD L,06H
   CALL SOUN2K
   LD L,06H
BITEND:
   CALL SOUN1K
   EXX
   RET
;---------------------- TEST, 0B (HL) RAM IST -------
;                      2 x INVERTIERTES SCHREIBEN UND
;                      LESEN AUS/IN DEN DURCH HL ANGEG.
;                      SPEICHERPLATZ UND VERGLEICHEN
;                      AUSGABE: Z=1, WENN RAM

RAMCHK:
   LD A,(HL)
   CPL
   LD (HL),A
   LD A,(HL)
   CPL
   LD (HL),A
   CP (HL)
   RET

;--------------------- LED UND TASTATUR-ABFR.--------
DAK1:
   PUSH IX        ;ADR ANZ.TEXT RETTEN
   LD HL,FUFEFLAG
   BIT 7,(HL)     ;FEHLERFLAG TESTEN
   JR  Z,SCPRE    ;SPR., WENN KEIN FEHLER
   LD IX,ERR      ;ADR FEHLERTEXT
SCPRE:
   LD B,06H
SCNX:
   CALL DAK2
   JR NC,SCPRE    ;WDHLG., WENN TASTE NOCH GEDR.
   DJNZ SCNX
   RES 7,(HL)     ;FEHLERLAG LOESCHEN
   POP IX         ;ALTER TEXT
SCLOOP:
   CALL DAK2
   JR  C,SCLOOP   ;WDHLG., WENN KEINE TASTE GEDR.
   LD HL,KEYTAB   ;TASTE NACH TABELLE UMCODIEREN
   ADD A,L
   LD L,A
   JR NC,SCNCY
   INC H
SCNCY:
   LD A,(HL)      ;UMCODIERTER TASTENWERT
   RET

;----------------- LED U. TASTATUR-UP --------------
DAK2:
   SCF
   EX AF,AF'
   EXX
   LD C,0         ;TASTENNUMMER = 0
   LD E,11111011B ;BITMUSTER FUER DIGITANSTEUERUNG
KCOL:
   LD A,(IX)      ;SEGMENTE ANSTEUERN
   CPL
   OUT (SEGMENT),A
   LD A,E         ;DIGIT ANSTEUERN
   OUT (DIGITAP),A
   LD B,100       ;ZEITVERZOEGERUNG
   DJNZ $
   LD B,04H       ;ZEILENZAHL TASTENMATRIX
   IN A,(KEYIN)   ;TASTENWERT EINLESEN
   LD D,A         ;TEST, OB TASTE GEDRUECKT
KROW:
   RL D
   JR  C,NOKEY
   LD A,C
   EX AF,AF'
   ;WENN TASTE: -> CY=0, A = NUMMER
NOKEY:
   INC C          ;ABFRAGEZAEHLER ERHOEHEN
   DJNZ KROW      ;WDHLG., WENN NOCH NICHT ALLE ZEILEN
   INC IX         ;NAECHSTES ZEICHEN ZUR ANZEIGE
   RLC E
   LD A,0FFH
   OUT (DIGITAP),A;ANZEIGE AUS
   JR C,KCOL      ;GGF. NAECHSTE SPALTE
   LD DE,0FFFAH
   ADD IX,DE      ;WIEDERHERST. ANF.ADR DES ANZ.TEXTES
   EXX
   EX AF,AF'
   RET

;-------------------- ADRESSE ANZEIGEN -------------
ADRSDP:
   LD HL,ADRLED
   LD A,E         ;UNTERE 2 ZIFFERN
   CALL TWOSEG
   LD A,D         ;OBERE 2 ZIFFERN
   CALL TWOSEG
   RET

;---------------------- A-REG IN DAT-ANZ-SPEICHER ---
DADP:
   LD HL,DATLED
   CALL TWOSEG
   RET

;--------------------- -
ONESEG:
   PUSH HL
   PUSH DE
   LD HL,SEGTAB   ;ADR DER SEGMENTTABELLE
   AND 0FH        ;OBERES HALBBYTE AUSBLENDEN
   LD E,A
   LD D,0
   ADD HL,DE
   POP DE
   LD A,(HL)      ;KONVERTIERTE ZAHL NACH A
   POP HL
   RET

;--------------------- -
TWOSEG:
   PUSH AF
   CALL ONESEG    ;UNTERE ZIFFER UMWANDELN
   LD (HL),A      ;ABSPEICHERN
   INC HL         ;ADR FUER HINTERLEGUNG OBERE ZAHL
   POP AF         ;URSPRUENGL. ZAHL
   RRCA
   RRCA
   RRCA
   RRCA           ;OBERES HALBBYTE
   CALL ONESEG    ;OBERE ZIFFER UMWANDELN
   LD (HL),A      ;ABSPEICHERN
   INC HL         ;ADR GGF. NAECHSTE ZIFFER
   RET

;--------------------- MUSIKPROGRAMM -----------------
MONMUS:
   LD IY,SONG     ;ADR DER NOTEN
MUSIC:
   PUSH IY
   POP IX
MUSLOOP:
   LD A,(IX)
   ADD A,A
   RET C          ;WENN WERT >= 80H
   JP  M,MUSIC    ;WENN WERT >= 40H
   LD C,0
   BIT 6,A
   JR NZ,PLAY     ;WENN WERT >= 20H
   SET 1,C        ;AUSGABE-BIT
PLAY:
   AND 3FH
   LD HL,FRQTAB
   LD E,A
   LD D,0
   ADD HL,DE
   LD E,(HL)
   INC HL
   LD D,(HL)
   INC IX
   LD H,(IX)
   LD A,0FFH
TONE:
  LD L,D
TONOUT:
   OUT (DIGITAP),A
   LD B,E
DELAY:
   NOP
   DJNZ DELAY
   XOR C
   DEC L
   JR NZ,TONOUT
   DEC H
   JR NZ,TONE
   INC IX
   JR MUSLOOP

;--------------------- ANZEIGEMOD TESTEN -------------
TESTM:
   LD A,(ATCODE)
   CP 01H
   RET  Z
   CP 02H
   RET  Z
   POP HL         ;RUECKKEHRADR. LOESCHEN
  JP ERRDIS

;--------------------- FREQUENZTABELLE ---------------
FRQTAB:
  DEFW 1870H
  DEFW 1AD4h			;1A6AH ?
  DEFW 1B64H
  DEFW 1D5EH
  DEFW 1E59H
  DEFW 2054H
  DEFW 224FH
  DEFW 244BH
  DEFW 2646H
  DEFW 2942H
  DEFW 2B3FH
  DEFW 2E3BH
  DEFW 3138H
  DEFW 3335H
  DEFW 3732H
  DEFW 3A2FH
  DEFW 3D2CH
  DEFW 412AH
  DEFW 4527H
  DEFW 4925H
  DEFW 4D23H
  DEFW 5221H
  DEFW 571FH
  DEFW 5C1DH
  DEFW 621BH
  DEFW 671AH
  DEFW 6E18H
  DEFW 7417H
  DEFW 7B16H
  DEFW 8214H
  DEFW 8A13H
  DEFW 9212H

;---------------------- TEXTE ------------------------
DISP1:
   DEFB 0E7H      ;"0"
   DEFB 0EFH      ;"8"
   DEFB 08H       ;""
   DEFB 0C6H      ;"C"
   DEFB 0C2H      ;"L"
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 4EH       ;"F"
   DEFB 0E7H      ;"0"
DISP2:
   DEFB 00H       ;" "
   DEFB 048H      ;"R"
   DEFB 0CEH      ;"E"
   DEFB 0AEH      ;"S"
   DEFB 0E3H      ;"U"
   DEFB 000H      ;" "
DISP3:
   DEFB 000H      ;" "
   DEFB 0E7H      ;"0"
   DEFB 0C2H      ;"L"
   DEFB 0C2H      ;"L"
   DEFB 06FH      ;"A"
   DEFB 06BH      ;"H"
DISP4:
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 04EH      ;"F"
   DEFB 0AEH      ;"S"
   DEFB 0CEH      ;"E"
   DEFB 00H       ;" "
   DEFB 04EH      ;"F"
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 00H       ;" "
DISP5:
   DEFB 00H       ;" "
   DEFB 00H       ;" "
   DEFB 0CAH      ;"t"
   DEFB 68H       ;"n"
   DEFB 21H       ;"i"
   DEFB 00H       ;" "
DISP6:
   DEFB 0EFH      ;"8"
   DEFB 0ADH      ;"3"
   DEFB 00H       ;" "
   DEFB 0CAH      ;"t"
   DEFB 0AEH      ;"s"
   DEFB 48H       ;"r"
ERR:
   DEFB 00H       ;" "
   DEFB 48H       ;"r"
   DEFB 0E8H      ;"o"
   DEFB 48H       ;"e"
   DEFB 48H       ;"e"
   DEFB 0CEH      ;"E"

;--------------------- -
KSUFUN:
   DEFW KINC
   DEFB KINC-KINC ;"+"
   DEFB KDEC-KINC ;"-"
   DEFB KEXEC-KINC;"EXEC"
   DEFB 00H
   DEFB KDATA-KINC;"DATA"
   DEFB 00H
   DEFB 00H
   DEFB 00H
;--------------------- -
KFUN:
   DEFW KADRS
   DEFB 00H
   DEFB KADRS-KADRS;"ADRS"
   DEFB 00H
   DEFB 00H
   DEFB 00H
   DEFB 00H
   DEFB KTAPWR-KADRS;"TO TAPE"
   DEFB KTAPWR-KADRS;"FROM TAPE*
;--------------------- -
HTAB:
   DEFW HFIX
   DEFB HFIX-HFIX ; FEHLER
   DEFB HAD-HFIX  ;"ADRS"
   DEFB HDA-HFIX  ;
   DEFB 00H
   DEFB 00H
   DEFB 00H
   DEFB HTAPWR-HFIX;"TO TAPE"
   DEFB HTAPWR-HFIX;"FROM TAPE"
   DEFB 00H
   DEFB 00H
;--------------------- -
ITAB:
   DEFW IFIX
   DEFB IFIX-IFIX ;
   DEFB ADRADD-IFIX;
   DEFB ADRADD-IFIX;
   DEFB 00H
   DEFB 00H
   DEFB 00H
   DEFB TPFUN1-IFIX;
   DEFB TPFUN1-IFIX;
   DEFB 00H
   DEFB 00H
;--------------------- -
DTAB:
   DEFW DFIX
   DEFB 00H
   DEFB ADRDEC-DFIX;
   DEFB ADRDEC-DFIX;
   DEFB 00H
   DEFB 00H
   DEFB 00H
   DEFB TPTUN2-DFIX;
   DEFB TPTUN2-DFIX;
   DEFB 00H
   DEFB 00H
;--------------------- -
ETAB:
   DEFW EFIX
   DEFB 00H
   DEFB ADREXC-EFIX;
   DEFB ADREXC-EFIX;
   DEFB 00H
   DEFB 00H
   DEFB 00H
   DEFB EWT-EFIX  ;
   DEFB LOAD-EFIX ;
   DEFB 00H
   DEFB 00H
;----------------- TASTATURTABELLE -------------------
KEYTAB:
   DEFB 12H       ;EXECUTE
   DEFB 1FH       ;LOAD
   DEFB 1EH       ;STORE
   DEFB 0         ;NICHT BELEGT
   DEFB 0         ;ZIFFERN 0...F
   DEFB 1
   DEFB 2
   DEFB 3
   DEFB 4
   DEFB 5
   DEFB 6
   DEFB 7
   DEFB 8
   DEFB 9
   DEFB 0AH
   DEFB 0BH
   DEFB 0CH
   DEFB 0DH
   DEFB 0EH
   DEFB 0FH
   DEFB 19H       ;ADRESS
   DEFB 14H       ;DATA
   DEFB 10H       ;+
   DEFB 11H       ;-

;----------------------- CODE FUER HEX-ZIFFERN --------
SEGTAB:
   DEFB 0E7H      ; 0
   DEFB 21H       ; 1
   DEFB 0CDH      ; 2
   DEFB 0ADH      ; 3
   DEFB 2BH       ; 4
   DEFB 0AEH      ; 5
   DEFB 0EEH      ; 6
   DEFB 25H       ; 7
   DEFB 0EFH      ; 8
   DEFB 0AFH      ; 9
   DEFB 6FH       ; A
   DEFB 0EAH      ; B
   DEFB 0C6H      ; C
   DEFB 0E9H      ; D
   DEFB 0CEH      ; E
   DEFB 4EH       ; F

;---------------------- LIED ------------------------
SONG:
   DEFW 0212H
   DEFW 0220H
   DEFW 0210H
   DEFW 0220H
   DEFW 0212H
   DEFW 0220H
   DEFW 020DH
   DEFW 0220H
   DEFW 0209H
   DEFW 0220H
   DEFW 020DH
   DEFW 0220H
   DEFW 0206H
   DEFW 0620H
   DEFW 0212H
   DEFW 0220H
   DEFW 0210H
   DEFW 0220H
   DEFW 0212H
   DEFW 0220H
   DEFW 020DH
   DEFW 0220H
   DEFW 0209H
   DEFW 0220H
   DEFW 020DH
   DEFW 0220H
   DEFW 0206H
   DEFW 0620H
   DEFW 0212H
   DEFW 0220H
   DEFW 0214H
   DEFW 0220H
   DEFW 0215H
   DEFW 0220H
   DEFW 0214H
   DEFW 0220H
   DEFW 0215H
   DEFW 0220H
   DEFW 0212H
   DEFW 0220H
   DEFW 0214H
   DEFW 0220H
   DEFW 0212H
   DEFW 0220H
   DEFW 0214H
   DEFW 0220H
   DEFW 0210H
   DEFW 0220H
   DEFW 0212H
   DEFW 0220H
   DEFW 0210H
   DEFW 0220H
   DEFW 0212H
   DEFW 0220H
   DEFW 020DH
   DEFW 0220H
   DEFW 0412H
   DEFW 0620H
   DEFB 80H
;-----------------------------------------------------


;***************************************************
;         RAM-ZELLEN

         ORG 13EAH

SPINI    EQU $    ;ANF.WERT FUER SP
TAPDIS:   Db 1 dup(?)  ;DARZUSTELLENDES  ZEICHEN BEI LOAD
FILNAME:  Db 2 dup(?)  ;NAME DES ZU UEBERTR. PROG.
STARTADR: Db 2 dup(?)
ENDADRH:  Db 2 dup(?)
CHKSUMH:  Db 1 dup(?)
DATLED:   Db 2 dup(?)  ;DATEN-ANZ.
ADRLED:   Db 4 dup(?)  ;ADR.-ANZ.
USERPC:   Db 2 dup(?)  ;ADRESSE
ATFLAG:   Db 1 dup(?)  ; 0 <-- ADRS, TO TAPE, FROM TAPE
ATCODE:   Db 1 dup(?)  ; 1-ADRS, 6-TO TAPE, 7-FROM TAPE
INIFLAG:  Db 1 dup(?)  ;INI-CODE
FUFEFLAG: Db 1 dup(?)
FILE2:    Db 2 dup(?)

;*****************************************************
 END
